/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2001-2010 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: sh_scif.h 15 2006-10-30 07:37:23Z honda $
 */

/*
 *   SH SCIF ʰSIOɥ饤
 *   
 *   ƥ¸֤ˡpdic/shǥ쥯ȥ֤Ƥ
 *   Τϡsh1/2ash3/4aǶͭ뤿
 */

#ifndef TOPPERS_SH_SCIF_H
#define TOPPERS_SH_SCIF_H

#ifndef TOPPERS_MACRO_ONLY

#include "kernel.h"	/*  INTNO  */

/*
 *  ꥢI/Oݡȴ֥å
 */
typedef struct sio_port_control_block	SIOPCB;

/*
 *  Хå롼μֹ
 */
#define SIO_RDY_SND    1U        /* ǽХå */
#define SIO_RDY_RCV    2U        /* ΥХå */

/*
 *  SIOɥ饤Фν롼
 */
extern void sh_scif_initialize(void);

/*
 * ͥ뵯ưΥСʽѤν
 */
extern void sh_scif_init(ID siopid);

/*
 *  ꥢI/OݡȤؤΥݡ󥰤Ǥν
 */
extern void sh_scif_pol_putc(char_t c, ID siopid);

/*
 *  ꥢI/OݡȤΥץ
 */
extern SIOPCB *sh_scif_opn_por(ID siopid, intptr_t exinf);

/*
 *  ꥢI/OݡȤΥ
 */
extern void sh_scif_cls_por(SIOPCB *p_siopcb);

/*
 *  ꥢI/OݡȤؤʸ
 */
extern bool_t sh_scif_snd_chr(SIOPCB *p_siopcb, char_t c);

/*
 *  ꥢI/OݡȤʸ
 */
extern int_t sh_scif_rcv_chr(SIOPCB *p_siopcb);

/*
 *  ꥢI/OݡȤΥХåε
 */
extern void  sh_scif_ena_cbr(SIOPCB *p_siopcb, uint_t cbrtn);

/*
 *  ꥢI/OݡȤΥХåζػ
 */
extern void sh_scif_dis_cbr(SIOPCB *p_siopcb, uint_t cbrtn);

/*
 *  SIOγߥӥ롼
 */
extern void sh_scif_tx_isr(ID siopid);
extern void sh_scif_rx_isr(ID siopid);

/*
 *  ꥢI/OݡȤǽХå
 */
extern void sh_scif_irdy_snd(intptr_t exinf);

/*
 *  ꥢI/OݡȤμΥХå
 */
extern void sh_scif_irdy_rcv(intptr_t exinf);


/*
 *  ݡֹ椫֥åƬϤؤѴ
 */
extern SIOPCB *sh_scif_get_siopcb(ID siopid);

/*
 * ֥åƬϤֹؤѴ
 */
extern INTNO sh_scif_intno_rx(SIOPCB *p_siopcb);

/*
 * ֥åƬϤֹؤѴ
 */
extern INTNO sh_scif_intno_tx(SIOPCB *p_siopcb);


#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_SH_SCIF_H */
